diff --git a/.idea/IntelliLang.xml b/.idea/IntelliLang.xml
new file mode 100644
index 0000000..b223a1b
--- /dev/null
+++ b/.idea/IntelliLang.xml
@@ -0,0 +1,151 @@
+
+
+
+
+ AsyncQueryRunner (org.apache.commons.dbutils)
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ Jodd (jodd.db)
+
+
+
+
+
+
+
+ MyBatis @Select/@Delete/@Insert/@Update
+
+
+
+
+
+
+
+ QueryRunner (org.apache.commons.dbutils)
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ R2DBC (io.r2dbc)
+
+
+
+
+
+ Reactiverse Postgres Client (io.reactiverse)
+
+
+
+
+
+
+
+
+
+
+
+
+ SmallRye Axle SqlClient (io.vertx.axle.sqlclient)
+
+
+
+
+
+ SmallRye Mutiny SqlClient (io.vertx.mutiny.sqlclient)
+
+
+
+
+
+ SmallRye Mutiny SqlConnection (io.vertx.mutiny.sqlclient)
+
+
+
+
+
+
+
+ Vert.x SQL Extensions (io.vertx.ext.sql)
+
+
+
+
+
+
+ Vert.x SQL Reactive Extensions (io.vertx.reactivex.ext.sql)
+
+
+
+
+
+
+
+
+
+ Vert.x SqlClient (io.vertx.sqlclient)
+
+
+
+
+
+
+
+
+
+
+ Vert.x SqlClient RxJava2 (io.vertx.reactivex.sqlclient)
+
+
+
+
+
+
+
+
+
+
+
+ jOOQ (org.jooq.DSLContext)
+
+
+
+
+
+
+
+ rxjava2-jdbc (org.davidmoten.rx.jdbc)
+
+
+
+
+
+
+
\ No newline at end of file
diff --git a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloReply$1.class b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloReply$1.class
index 89eca99..17b1915 100644
Binary files a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloReply$1.class and b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloReply$1.class differ
diff --git a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloReply$Builder.class b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloReply$Builder.class
index 201e71a..cbbd111 100644
Binary files a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloReply$Builder.class and b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloReply$Builder.class differ
diff --git a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloReply.class b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloReply.class
index 0f73957..c4910cd 100644
Binary files a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloReply.class and b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloReply.class differ
diff --git a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloRequest$1.class b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloRequest$1.class
index 906e095..d78eafc 100644
Binary files a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloRequest$1.class and b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloRequest$1.class differ
diff --git a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloRequest$Builder.class b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloRequest$Builder.class
index 3edc4e4..eb14e18 100644
Binary files a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloRequest$Builder.class and b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloRequest$Builder.class differ
diff --git a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloRequest.class b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloRequest.class
index 4fb6b44..aa478c5 100644
Binary files a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloRequest.class and b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloRequest.class differ
diff --git a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$1.class b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$1.class
index df899e7..d27c17e 100644
Binary files a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$1.class and b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$1.class differ
diff --git a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$2.class b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$2.class
index 47b92b9..13a5b02 100644
Binary files a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$2.class and b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$2.class differ
diff --git a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$3.class b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$3.class
index 20d37f4..6825897 100644
Binary files a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$3.class and b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$3.class differ
diff --git a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceBaseDescriptorSupplier.class b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceBaseDescriptorSupplier.class
index b1127eb..fc53cdb 100644
Binary files a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceBaseDescriptorSupplier.class and b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceBaseDescriptorSupplier.class differ
diff --git a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceBlockingStub.class b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceBlockingStub.class
index a3792b5..e8acac3 100644
Binary files a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceBlockingStub.class and b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceBlockingStub.class differ
diff --git a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceFileDescriptorSupplier.class b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceFileDescriptorSupplier.class
index bfd2f42..bcf9b16 100644
Binary files a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceFileDescriptorSupplier.class and b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceFileDescriptorSupplier.class differ
diff --git a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceFutureStub.class b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceFutureStub.class
index 5cf8d7b..38ff876 100644
Binary files a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceFutureStub.class and b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceFutureStub.class differ
diff --git a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceImplBase.class b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceImplBase.class
index 1cdf483..1f032fd 100644
Binary files a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceImplBase.class and b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceImplBase.class differ
diff --git a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceMethodDescriptorSupplier.class b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceMethodDescriptorSupplier.class
index 321cf7f..254aa09 100644
Binary files a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceMethodDescriptorSupplier.class and b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceMethodDescriptorSupplier.class differ
diff --git a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceStub.class b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceStub.class
index d0baa41..355f1e6 100644
Binary files a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceStub.class and b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$HelloWorldServiceStub.class differ
diff --git a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$MethodHandlers.class b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$MethodHandlers.class
index 8572229..f79c005 100644
Binary files a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$MethodHandlers.class and b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc$MethodHandlers.class differ
diff --git a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc.class b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc.class
index b5884f8..a5f135e 100644
Binary files a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc.class and b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceGrpc.class differ
diff --git a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceImpl.class b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceImpl.class
index b23f3e1..7339d25 100644
Binary files a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceImpl.class and b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceImpl.class differ
diff --git a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceProtos.class b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceProtos.class
index 037eb93..31ca865 100644
Binary files a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceProtos.class and b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/HelloWorldServiceProtos.class differ
diff --git a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/client/HelloWorldClient.class b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/client/HelloWorldClient.class
index 923e295..851181e 100644
Binary files a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/client/HelloWorldClient.class and b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/client/HelloWorldClient.class differ
diff --git a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/server/HelloWorldServer.class b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/server/HelloWorldServer.class
index e84fe77..d49f1f7 100644
Binary files a/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/server/HelloWorldServer.class and b/week3_TinsaeGhilay/Task 7/example/target/classes/org/tinsae/grpc/server/HelloWorldServer.class differ
diff --git a/week4_TinsaeGhilay/Task 1/target/classes/com/tinsae/crawler/CrawlTask.class b/week4_TinsaeGhilay/Task 1/target/classes/com/tinsae/crawler/CrawlTask.class
index 2a38d24..40fc878 100644
Binary files a/week4_TinsaeGhilay/Task 1/target/classes/com/tinsae/crawler/CrawlTask.class and b/week4_TinsaeGhilay/Task 1/target/classes/com/tinsae/crawler/CrawlTask.class differ
diff --git a/week4_TinsaeGhilay/Task 1/target/classes/com/tinsae/crawler/Crawler.class b/week4_TinsaeGhilay/Task 1/target/classes/com/tinsae/crawler/Crawler.class
index ba4c2f8..bdedc6b 100644
Binary files a/week4_TinsaeGhilay/Task 1/target/classes/com/tinsae/crawler/Crawler.class and b/week4_TinsaeGhilay/Task 1/target/classes/com/tinsae/crawler/Crawler.class differ
diff --git a/week4_TinsaeGhilay/Task 1/target/classes/com/tinsae/crawler/Main.class b/week4_TinsaeGhilay/Task 1/target/classes/com/tinsae/crawler/Main.class
index 0f233fc..0025c18 100644
Binary files a/week4_TinsaeGhilay/Task 1/target/classes/com/tinsae/crawler/Main.class and b/week4_TinsaeGhilay/Task 1/target/classes/com/tinsae/crawler/Main.class differ
diff --git a/week5_TinsaeGhilay/shop/.gitignore b/week5_TinsaeGhilay/shop/.gitignore
new file mode 100644
index 0000000..480bdf5
--- /dev/null
+++ b/week5_TinsaeGhilay/shop/.gitignore
@@ -0,0 +1,39 @@
+target/
+!.mvn/wrapper/maven-wrapper.jar
+!**/src/main/**/target/
+!**/src/test/**/target/
+.kotlin
+
+### IntelliJ IDEA ###
+.idea/modules.xml
+.idea/jarRepositories.xml
+.idea/compiler.xml
+.idea/libraries/
+*.iws
+*.iml
+*.ipr
+
+### Eclipse ###
+.apt_generated
+.classpath
+.factorypath
+.project
+.settings
+.springBeans
+.sts4-cache
+
+### NetBeans ###
+/nbproject/private/
+/nbbuild/
+/dist/
+/nbdist/
+/.nb-gradle/
+build/
+!**/src/main/**/build/
+!**/src/test/**/build/
+
+### VS Code ###
+.vscode/
+
+### Mac OS ###
+.DS_Store
\ No newline at end of file
diff --git a/week5_TinsaeGhilay/shop/.idea/.gitignore b/week5_TinsaeGhilay/shop/.idea/.gitignore
new file mode 100644
index 0000000..ab1f416
--- /dev/null
+++ b/week5_TinsaeGhilay/shop/.idea/.gitignore
@@ -0,0 +1,10 @@
+# Default ignored files
+/shelf/
+/workspace.xml
+# Ignored default folder with query files
+/queries/
+# Datasource local storage ignored files
+/dataSources/
+/dataSources.local.xml
+# Editor-based HTTP Client requests
+/httpRequests/
diff --git a/week5_TinsaeGhilay/shop/.idea/dataSources.xml b/week5_TinsaeGhilay/shop/.idea/dataSources.xml
new file mode 100644
index 0000000..2a67e29
--- /dev/null
+++ b/week5_TinsaeGhilay/shop/.idea/dataSources.xml
@@ -0,0 +1,12 @@
+
+
+
+
+ sqlite.xerial
+ true
+ org.sqlite.JDBC
+ jdbc:sqlite:$USER_HOME$/test_sqlite.sqlite
+ $ProjectFileDir$
+
+
+
\ No newline at end of file
diff --git a/week5_TinsaeGhilay/shop/.idea/encodings.xml b/week5_TinsaeGhilay/shop/.idea/encodings.xml
new file mode 100644
index 0000000..aa00ffa
--- /dev/null
+++ b/week5_TinsaeGhilay/shop/.idea/encodings.xml
@@ -0,0 +1,7 @@
+
+
+
+
+
+
+
\ No newline at end of file
diff --git a/week5_TinsaeGhilay/shop/.idea/misc.xml b/week5_TinsaeGhilay/shop/.idea/misc.xml
new file mode 100644
index 0000000..fe18481
--- /dev/null
+++ b/week5_TinsaeGhilay/shop/.idea/misc.xml
@@ -0,0 +1,14 @@
+
+
+
+
+
+
+
+
+
+
\ No newline at end of file
diff --git a/week5_TinsaeGhilay/shop/.idea/sqldialects.xml b/week5_TinsaeGhilay/shop/.idea/sqldialects.xml
new file mode 100644
index 0000000..5aeb957
--- /dev/null
+++ b/week5_TinsaeGhilay/shop/.idea/sqldialects.xml
@@ -0,0 +1,7 @@
+
+
+
+
+
+
+
\ No newline at end of file
diff --git a/week5_TinsaeGhilay/shop/.mvn/wrapper/maven-wrapper.jar b/week5_TinsaeGhilay/shop/.mvn/wrapper/maven-wrapper.jar
new file mode 100644
index 0000000..c1dd12f
Binary files /dev/null and b/week5_TinsaeGhilay/shop/.mvn/wrapper/maven-wrapper.jar differ
diff --git a/week5_TinsaeGhilay/shop/.mvn/wrapper/maven-wrapper.properties b/week5_TinsaeGhilay/shop/.mvn/wrapper/maven-wrapper.properties
new file mode 100644
index 0000000..41d2d76
--- /dev/null
+++ b/week5_TinsaeGhilay/shop/.mvn/wrapper/maven-wrapper.properties
@@ -0,0 +1,2 @@
+distributionUrl=https://repo.maven.apache.org/maven2/org/apache/maven/apache-maven/3.9.6/apache-maven-3.9.6-bin.zip
+wrapperUrl=https://repo.maven.apache.org/maven2/org/apache/maven/wrapper/maven-wrapper/3.3.0/maven-wrapper-3.3.0.jar
\ No newline at end of file
diff --git a/week5_TinsaeGhilay/shop/mvnw b/week5_TinsaeGhilay/shop/mvnw
new file mode 100755
index 0000000..8a8fb22
--- /dev/null
+++ b/week5_TinsaeGhilay/shop/mvnw
@@ -0,0 +1,316 @@
+#!/bin/sh
+# ----------------------------------------------------------------------------
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# https://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied. See the License for the
+# specific language governing permissions and limitations
+# under the License.
+# ----------------------------------------------------------------------------
+
+# ----------------------------------------------------------------------------
+# Maven Start Up Batch script
+#
+# Required ENV vars:
+# ------------------
+# JAVA_HOME - location of a JDK home dir
+#
+# Optional ENV vars
+# -----------------
+# M2_HOME - location of maven2's installed home dir
+# MAVEN_OPTS - parameters passed to the Java VM when running Maven
+# e.g. to debug Maven itself, use
+# set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+# MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+# ----------------------------------------------------------------------------
+
+if [ -z "$MAVEN_SKIP_RC" ] ; then
+
+ if [ -f /usr/local/etc/mavenrc ] ; then
+ . /usr/local/etc/mavenrc
+ fi
+
+ if [ -f /etc/mavenrc ] ; then
+ . /etc/mavenrc
+ fi
+
+ if [ -f "$HOME/.mavenrc" ] ; then
+ . "$HOME/.mavenrc"
+ fi
+
+fi
+
+# OS specific support. $var _must_ be set to either true or false.
+cygwin=false;
+darwin=false;
+mingw=false
+case "`uname`" in
+ CYGWIN*) cygwin=true ;;
+ MINGW*) mingw=true;;
+ Darwin*) darwin=true
+ # Use /usr/libexec/java_home if available, otherwise fall back to /Library/Java/Home
+ # See https://developer.apple.com/library/mac/qa/qa1170/_index.html
+ if [ -z "$JAVA_HOME" ]; then
+ if [ -x "/usr/libexec/java_home" ]; then
+ export JAVA_HOME="`/usr/libexec/java_home`"
+ else
+ export JAVA_HOME="/Library/Java/Home"
+ fi
+ fi
+ ;;
+esac
+
+if [ -z "$JAVA_HOME" ] ; then
+ if [ -r /etc/gentoo-release ] ; then
+ JAVA_HOME=`java-config --jre-home`
+ fi
+fi
+
+if [ -z "$M2_HOME" ] ; then
+ ## resolve links - $0 may be a link to maven's home
+ PRG="$0"
+
+ # need this for relative symlinks
+ while [ -h "$PRG" ] ; do
+ ls=`ls -ld "$PRG"`
+ link=`expr "$ls" : '.*-> \(.*\)$'`
+ if expr "$link" : '/.*' > /dev/null; then
+ PRG="$link"
+ else
+ PRG="`dirname "$PRG"`/$link"
+ fi
+ done
+
+ saveddir=`pwd`
+
+ M2_HOME=`dirname "$PRG"`/..
+
+ # make it fully qualified
+ M2_HOME=`cd "$M2_HOME" && pwd`
+
+ cd "$saveddir"
+ # echo Using m2 at $M2_HOME
+fi
+
+# For Cygwin, ensure paths are in UNIX format before anything is touched
+if $cygwin ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --unix "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --unix "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --unix "$CLASSPATH"`
+fi
+
+# For Mingw, ensure paths are in UNIX format before anything is touched
+if $mingw ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME="`(cd "$M2_HOME"; pwd)`"
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME="`(cd "$JAVA_HOME"; pwd)`"
+fi
+
+if [ -z "$JAVA_HOME" ]; then
+ javaExecutable="`which javac`"
+ if [ -n "$javaExecutable" ] && ! [ "`expr \"$javaExecutable\" : '\([^ ]*\)'`" = "no" ]; then
+ # readlink(1) is not available as standard on Solaris 10.
+ readLink=`which readlink`
+ if [ ! `expr "$readLink" : '\([^ ]*\)'` = "no" ]; then
+ if $darwin ; then
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaExecutable="`cd \"$javaHome\" && pwd -P`/javac"
+ else
+ javaExecutable="`readlink -f \"$javaExecutable\"`"
+ fi
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaHome=`expr "$javaHome" : '\(.*\)/bin'`
+ JAVA_HOME="$javaHome"
+ export JAVA_HOME
+ fi
+ fi
+fi
+
+if [ -z "$JAVACMD" ] ; then
+ if [ -n "$JAVA_HOME" ] ; then
+ if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
+ # IBM's JDK on AIX uses strange locations for the executables
+ JAVACMD="$JAVA_HOME/jre/sh/java"
+ else
+ JAVACMD="$JAVA_HOME/bin/java"
+ fi
+ else
+ JAVACMD="`\\unset -f command; \\command -v java`"
+ fi
+fi
+
+if [ ! -x "$JAVACMD" ] ; then
+ echo "Error: JAVA_HOME is not defined correctly." >&2
+ echo " We cannot execute $JAVACMD" >&2
+ exit 1
+fi
+
+if [ -z "$JAVA_HOME" ] ; then
+ echo "Warning: JAVA_HOME environment variable is not set."
+fi
+
+CLASSWORLDS_LAUNCHER=org.codehaus.plexus.classworlds.launcher.Launcher
+
+# traverses directory structure from process work directory to filesystem root
+# first directory with .mvn subdirectory is considered project base directory
+find_maven_basedir() {
+
+ if [ -z "$1" ]
+ then
+ echo "Path not specified to find_maven_basedir"
+ return 1
+ fi
+
+ basedir="$1"
+ wdir="$1"
+ while [ "$wdir" != '/' ] ; do
+ if [ -d "$wdir"/.mvn ] ; then
+ basedir=$wdir
+ break
+ fi
+ # workaround for JBEAP-8937 (on Solaris 10/Sparc)
+ if [ -d "${wdir}" ]; then
+ wdir=`cd "$wdir/.."; pwd`
+ fi
+ # end of workaround
+ done
+ echo "${basedir}"
+}
+
+# concatenates all lines of a file
+concat_lines() {
+ if [ -f "$1" ]; then
+ echo "$(tr -s '\n' ' ' < "$1")"
+ fi
+}
+
+BASE_DIR=`find_maven_basedir "$(pwd)"`
+if [ -z "$BASE_DIR" ]; then
+ exit 1;
+fi
+
+##########################################################################################
+# Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+# This allows using the maven wrapper in projects that prohibit checking in binary data.
+##########################################################################################
+if [ -r "$BASE_DIR/.mvn/wrapper/maven-wrapper.jar" ]; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found .mvn/wrapper/maven-wrapper.jar"
+ fi
+else
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Couldn't find .mvn/wrapper/maven-wrapper.jar, downloading it ..."
+ fi
+ if [ -n "$MVNW_REPOURL" ]; then
+ jarUrl="$MVNW_REPOURL/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+ else
+ jarUrl="https://repo.maven.apache.org/maven2/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+ fi
+ while IFS="=" read key value; do
+ case "$key" in (wrapperUrl) jarUrl="$value"; break ;;
+ esac
+ done < "$BASE_DIR/.mvn/wrapper/maven-wrapper.properties"
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Downloading from: $jarUrl"
+ fi
+ wrapperJarPath="$BASE_DIR/.mvn/wrapper/maven-wrapper.jar"
+ if $cygwin; then
+ wrapperJarPath=`cygpath --path --windows "$wrapperJarPath"`
+ fi
+
+ if command -v wget > /dev/null; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found wget ... using wget"
+ fi
+ if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+ wget "$jarUrl" -O "$wrapperJarPath" || rm -f "$wrapperJarPath"
+ else
+ wget --http-user=$MVNW_USERNAME --http-password=$MVNW_PASSWORD "$jarUrl" -O "$wrapperJarPath" || rm -f "$wrapperJarPath"
+ fi
+ elif command -v curl > /dev/null; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found curl ... using curl"
+ fi
+ if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+ curl -o "$wrapperJarPath" "$jarUrl" -f
+ else
+ curl --user $MVNW_USERNAME:$MVNW_PASSWORD -o "$wrapperJarPath" "$jarUrl" -f
+ fi
+
+ else
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Falling back to using Java to download"
+ fi
+ javaClass="$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.java"
+ # For Cygwin, switch paths to Windows format before running javac
+ if $cygwin; then
+ javaClass=`cygpath --path --windows "$javaClass"`
+ fi
+ if [ -e "$javaClass" ]; then
+ if [ ! -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo " - Compiling MavenWrapperDownloader.java ..."
+ fi
+ # Compiling the Java class
+ ("$JAVA_HOME/bin/javac" "$javaClass")
+ fi
+ if [ -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+ # Running the downloader
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo " - Running MavenWrapperDownloader.java ..."
+ fi
+ ("$JAVA_HOME/bin/java" -cp .mvn/wrapper MavenWrapperDownloader "$MAVEN_PROJECTBASEDIR")
+ fi
+ fi
+ fi
+fi
+##########################################################################################
+# End of extension
+##########################################################################################
+
+export MAVEN_PROJECTBASEDIR=${MAVEN_BASEDIR:-"$BASE_DIR"}
+if [ "$MVNW_VERBOSE" = true ]; then
+ echo $MAVEN_PROJECTBASEDIR
+fi
+MAVEN_OPTS="$(concat_lines "$MAVEN_PROJECTBASEDIR/.mvn/jvm.config") $MAVEN_OPTS"
+
+# For Cygwin, switch paths to Windows format before running java
+if $cygwin; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --path --windows "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --path --windows "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --windows "$CLASSPATH"`
+ [ -n "$MAVEN_PROJECTBASEDIR" ] &&
+ MAVEN_PROJECTBASEDIR=`cygpath --path --windows "$MAVEN_PROJECTBASEDIR"`
+fi
+
+# Provide a "standardized" way to retrieve the CLI args that will
+# work with both Windows and non-Windows executions.
+MAVEN_CMD_LINE_ARGS="$MAVEN_CONFIG $@"
+export MAVEN_CMD_LINE_ARGS
+
+WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+exec "$JAVACMD" \
+ $MAVEN_OPTS \
+ $MAVEN_DEBUG_OPTS \
+ -classpath "$MAVEN_PROJECTBASEDIR/.mvn/wrapper/maven-wrapper.jar" \
+ "-Dmaven.home=${M2_HOME}" \
+ "-Dmaven.multiModuleProjectDirectory=${MAVEN_PROJECTBASEDIR}" \
+ ${WRAPPER_LAUNCHER} $MAVEN_CONFIG "$@"
diff --git a/week5_TinsaeGhilay/shop/mvnw.cmd b/week5_TinsaeGhilay/shop/mvnw.cmd
new file mode 100644
index 0000000..1d8ab01
--- /dev/null
+++ b/week5_TinsaeGhilay/shop/mvnw.cmd
@@ -0,0 +1,188 @@
+@REM ----------------------------------------------------------------------------
+@REM Licensed to the Apache Software Foundation (ASF) under one
+@REM or more contributor license agreements. See the NOTICE file
+@REM distributed with this work for additional information
+@REM regarding copyright ownership. The ASF licenses this file
+@REM to you under the Apache License, Version 2.0 (the
+@REM "License"); you may not use this file except in compliance
+@REM with the License. You may obtain a copy of the License at
+@REM
+@REM https://www.apache.org/licenses/LICENSE-2.0
+@REM
+@REM Unless required by applicable law or agreed to in writing,
+@REM software distributed under the License is distributed on an
+@REM "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+@REM KIND, either express or implied. See the License for the
+@REM specific language governing permissions and limitations
+@REM under the License.
+@REM ----------------------------------------------------------------------------
+
+@REM ----------------------------------------------------------------------------
+@REM Maven Start Up Batch script
+@REM
+@REM Required ENV vars:
+@REM JAVA_HOME - location of a JDK home dir
+@REM
+@REM Optional ENV vars
+@REM M2_HOME - location of maven2's installed home dir
+@REM MAVEN_BATCH_ECHO - set to 'on' to enable the echoing of the batch commands
+@REM MAVEN_BATCH_PAUSE - set to 'on' to wait for a keystroke before ending
+@REM MAVEN_OPTS - parameters passed to the Java VM when running Maven
+@REM e.g. to debug Maven itself, use
+@REM set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+@REM MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+@REM ----------------------------------------------------------------------------
+
+@REM Begin all REM lines with '@' in case MAVEN_BATCH_ECHO is 'on'
+@echo off
+@REM set title of command window
+title %0
+@REM enable echoing by setting MAVEN_BATCH_ECHO to 'on'
+@if "%MAVEN_BATCH_ECHO%" == "on" echo %MAVEN_BATCH_ECHO%
+
+@REM set %HOME% to equivalent of $HOME
+if "%HOME%" == "" (set "HOME=%HOMEDRIVE%%HOMEPATH%")
+
+@REM Execute a user defined script before this one
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPre
+@REM check for pre script, once with legacy .bat ending and once with .cmd ending
+if exist "%USERPROFILE%\mavenrc_pre.bat" call "%USERPROFILE%\mavenrc_pre.bat" %*
+if exist "%USERPROFILE%\mavenrc_pre.cmd" call "%USERPROFILE%\mavenrc_pre.cmd" %*
+:skipRcPre
+
+@setlocal
+
+set ERROR_CODE=0
+
+@REM To isolate internal variables from possible post scripts, we use another setlocal
+@setlocal
+
+@REM ==== START VALIDATION ====
+if not "%JAVA_HOME%" == "" goto OkJHome
+
+echo.
+echo Error: JAVA_HOME not found in your environment. >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+:OkJHome
+if exist "%JAVA_HOME%\bin\java.exe" goto init
+
+echo.
+echo Error: JAVA_HOME is set to an invalid directory. >&2
+echo JAVA_HOME = "%JAVA_HOME%" >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+@REM ==== END VALIDATION ====
+
+:init
+
+@REM Find the project base dir, i.e. the directory that contains the folder ".mvn".
+@REM Fallback to current working directory if not found.
+
+set MAVEN_PROJECTBASEDIR=%MAVEN_BASEDIR%
+IF NOT "%MAVEN_PROJECTBASEDIR%"=="" goto endDetectBaseDir
+
+set EXEC_DIR=%CD%
+set WDIR=%EXEC_DIR%
+:findBaseDir
+IF EXIST "%WDIR%"\.mvn goto baseDirFound
+cd ..
+IF "%WDIR%"=="%CD%" goto baseDirNotFound
+set WDIR=%CD%
+goto findBaseDir
+
+:baseDirFound
+set MAVEN_PROJECTBASEDIR=%WDIR%
+cd "%EXEC_DIR%"
+goto endDetectBaseDir
+
+:baseDirNotFound
+set MAVEN_PROJECTBASEDIR=%EXEC_DIR%
+cd "%EXEC_DIR%"
+
+:endDetectBaseDir
+
+IF NOT EXIST "%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config" goto endReadAdditionalConfig
+
+@setlocal EnableExtensions EnableDelayedExpansion
+for /F "usebackq delims=" %%a in ("%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config") do set JVM_CONFIG_MAVEN_PROPS=!JVM_CONFIG_MAVEN_PROPS! %%a
+@endlocal & set JVM_CONFIG_MAVEN_PROPS=%JVM_CONFIG_MAVEN_PROPS%
+
+:endReadAdditionalConfig
+
+SET MAVEN_JAVA_EXE="%JAVA_HOME%\bin\java.exe"
+set WRAPPER_JAR="%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.jar"
+set WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+set DOWNLOAD_URL="https://repo.maven.apache.org/maven2/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+
+FOR /F "usebackq tokens=1,2 delims==" %%A IN ("%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.properties") DO (
+ IF "%%A"=="wrapperUrl" SET DOWNLOAD_URL=%%B
+)
+
+@REM Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+@REM This allows using the maven wrapper in projects that prohibit checking in binary data.
+if exist %WRAPPER_JAR% (
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Found %WRAPPER_JAR%
+ )
+) else (
+ if not "%MVNW_REPOURL%" == "" (
+ SET DOWNLOAD_URL="%MVNW_REPOURL%/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+ )
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Couldn't find %WRAPPER_JAR%, downloading it ...
+ echo Downloading from: %DOWNLOAD_URL%
+ )
+
+ powershell -Command "&{"^
+ "$webclient = new-object System.Net.WebClient;"^
+ "if (-not ([string]::IsNullOrEmpty('%MVNW_USERNAME%') -and [string]::IsNullOrEmpty('%MVNW_PASSWORD%'))) {"^
+ "$webclient.Credentials = new-object System.Net.NetworkCredential('%MVNW_USERNAME%', '%MVNW_PASSWORD%');"^
+ "}"^
+ "[Net.ServicePointManager]::SecurityProtocol = [Net.SecurityProtocolType]::Tls12; $webclient.DownloadFile('%DOWNLOAD_URL%', '%WRAPPER_JAR%')"^
+ "}"
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Finished downloading %WRAPPER_JAR%
+ )
+)
+@REM End of extension
+
+@REM Provide a "standardized" way to retrieve the CLI args that will
+@REM work with both Windows and non-Windows executions.
+set MAVEN_CMD_LINE_ARGS=%*
+
+%MAVEN_JAVA_EXE% ^
+ %JVM_CONFIG_MAVEN_PROPS% ^
+ %MAVEN_OPTS% ^
+ %MAVEN_DEBUG_OPTS% ^
+ -classpath %WRAPPER_JAR% ^
+ "-Dmaven.multiModuleProjectDirectory=%MAVEN_PROJECTBASEDIR%" ^
+ %WRAPPER_LAUNCHER% %MAVEN_CONFIG% %*
+if ERRORLEVEL 1 goto error
+goto end
+
+:error
+set ERROR_CODE=1
+
+:end
+@endlocal & set ERROR_CODE=%ERROR_CODE%
+
+if not "%MAVEN_SKIP_RC%"=="" goto skipRcPost
+@REM check for post script, once with legacy .bat ending and once with .cmd ending
+if exist "%USERPROFILE%\mavenrc_post.bat" call "%USERPROFILE%\mavenrc_post.bat"
+if exist "%USERPROFILE%\mavenrc_post.cmd" call "%USERPROFILE%\mavenrc_post.cmd"
+:skipRcPost
+
+@REM pause the script if MAVEN_BATCH_PAUSE is set to 'on'
+if "%MAVEN_BATCH_PAUSE%"=="on" pause
+
+if "%MAVEN_TERMINATE_CMD%"=="on" exit %ERROR_CODE%
+
+cmd /C exit /B %ERROR_CODE%
diff --git a/week5_TinsaeGhilay/shop/pom.xml b/week5_TinsaeGhilay/shop/pom.xml
new file mode 100644
index 0000000..1adc2c3
--- /dev/null
+++ b/week5_TinsaeGhilay/shop/pom.xml
@@ -0,0 +1,68 @@
+
+
+ 4.0.0
+
+ net.tinsae.rest
+ shop
+ 1.0-SNAPSHOT
+ shop
+ war
+
+
+ UTF-8
+ 21
+ 21
+ 5.13.2
+
+
+
+
+ jakarta.enterprise
+ jakarta.enterprise.cdi-api
+ 4.1.0
+ provided
+
+
+ jakarta.ws.rs
+ jakarta.ws.rs-api
+ 4.0.0
+ provided
+
+
+ org.xerial
+ sqlite-jdbc
+ 3.45.3.0
+
+
+
+ jakarta.servlet
+ jakarta.servlet-api
+ 6.1.0
+ provided
+
+
+ org.junit.jupiter
+ junit-jupiter-api
+ ${junit.version}
+ test
+
+
+ org.junit.jupiter
+ junit-jupiter-engine
+ ${junit.version}
+ test
+
+
+
+
+
+
+ org.apache.maven.plugins
+ maven-war-plugin
+ 3.4.0
+
+
+
+
\ No newline at end of file
diff --git a/week5_TinsaeGhilay/shop/src/main/java/net/tinsae/shop/App.java b/week5_TinsaeGhilay/shop/src/main/java/net/tinsae/shop/App.java
new file mode 100644
index 0000000..9d31726
--- /dev/null
+++ b/week5_TinsaeGhilay/shop/src/main/java/net/tinsae/shop/App.java
@@ -0,0 +1,10 @@
+package net.tinsae.shop;
+
+import jakarta.ws.rs.ApplicationPath;
+import jakarta.ws.rs.core.Application;
+
+
+@ApplicationPath("/api")
+public class App extends Application {
+
+}
\ No newline at end of file
diff --git a/week5_TinsaeGhilay/shop/src/main/java/net/tinsae/shop/Factory.java b/week5_TinsaeGhilay/shop/src/main/java/net/tinsae/shop/Factory.java
new file mode 100644
index 0000000..983e65f
--- /dev/null
+++ b/week5_TinsaeGhilay/shop/src/main/java/net/tinsae/shop/Factory.java
@@ -0,0 +1,49 @@
+package net.tinsae.shop;
+
+import jakarta.ws.rs.GET;
+import jakarta.ws.rs.Path;
+import jakarta.ws.rs.Produces;
+
+import jakarta.ws.rs.*;
+import jakarta.ws.rs.core.MediaType;
+import jakarta.ws.rs.core.Response;
+import java.util.List;
+
+@Produces(MediaType.APPLICATION_JSON)
+@Consumes(MediaType.APPLICATION_JSON)
+
+@Path("/items")
+public class Factory {
+ private final ItemDao dao = new ItemDao();
+
+ @GET
+ public List- getAllItems() {
+ return dao.findAll();
+ }
+
+ @GET
+ @Path("/{id}")
+ public Item getItem(@PathParam("id") int id) {
+ return dao.findById(id);
+ }
+ @POST
+ public Response createItem(Item Item) {
+ dao.insert(Item);
+ return Response.status(Response.Status.CREATED).build();
+ }
+
+ @PUT
+ @Path("/{id}")
+ public Response updateItem(@PathParam("id") int id, Item Item) {
+ Item.setId(id);
+ dao.update(Item);
+ return Response.ok().build();
+ }
+
+ @DELETE
+ @Path("/{id}")
+ public Response deleteItem(@PathParam("id") int id) {
+ dao.delete(id);
+ return Response.noContent().build();
+ }
+}
\ No newline at end of file
diff --git a/week5_TinsaeGhilay/shop/src/main/java/net/tinsae/shop/InvalidItemException.java b/week5_TinsaeGhilay/shop/src/main/java/net/tinsae/shop/InvalidItemException.java
new file mode 100644
index 0000000..da60422
--- /dev/null
+++ b/week5_TinsaeGhilay/shop/src/main/java/net/tinsae/shop/InvalidItemException.java
@@ -0,0 +1,12 @@
+package net.tinsae.shop;
+
+
+
+
+public class InvalidItemException extends RuntimeException {
+ public InvalidItemException(String message) {
+ super(message);
+ }
+}
+
+
diff --git a/week5_TinsaeGhilay/shop/src/main/java/net/tinsae/shop/Item.java b/week5_TinsaeGhilay/shop/src/main/java/net/tinsae/shop/Item.java
new file mode 100644
index 0000000..fcfb261
--- /dev/null
+++ b/week5_TinsaeGhilay/shop/src/main/java/net/tinsae/shop/Item.java
@@ -0,0 +1,66 @@
+package net.tinsae.shop;
+
+import java.sql.*;
+import java.util.*;
+
+
+public class Item{
+ private int id;
+ private String name, description;
+ private float price;
+
+ public Item(){}
+
+ public Item(String name, String description, float price){
+ this.name = name;
+ this.description=description;
+ this.price = price;
+ }
+
+ public Item(int id, String name, String description, float price){
+ this(name,description,price);
+ this.id = id;
+ }
+
+ public int getId() {
+ return id;
+ }
+
+ public void setId(int id) {
+ this.id = id;
+ }
+
+ public String getName() {
+ return name;
+ }
+
+ public void setName(String name) {
+ this.name = name;
+ }
+
+ public String getDescription() {
+ return description;
+ }
+
+ public void setDescription(String description) {
+ this.description = description;
+ }
+
+ public float getPrice() {
+ return price;
+ }
+
+ public void setPrice(float price) {
+ this.price = price;
+ }
+
+ public static Item createItem(int id, String name, String description, float price) {
+ if(name.isEmpty() || description.isEmpty() || price == 0.0){
+ throw new InvalidItemException("Invalid Item properties");
+ }else{
+ return new Item(id,name,description,price);
+ }
+ }
+
+
+}
\ No newline at end of file
diff --git a/week5_TinsaeGhilay/shop/src/main/java/net/tinsae/shop/ItemDao.java b/week5_TinsaeGhilay/shop/src/main/java/net/tinsae/shop/ItemDao.java
new file mode 100644
index 0000000..a6cc72c
--- /dev/null
+++ b/week5_TinsaeGhilay/shop/src/main/java/net/tinsae/shop/ItemDao.java
@@ -0,0 +1,113 @@
+package net.tinsae.shop;
+
+import java.sql.*;
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.List;
+
+class ItemDao{
+
+ public List
- findAll() {
+ String query = "SELECT * FROM items";
+ try( // with resource
+ var con = Util.getConnection();
+ var stm = con.prepareStatement(query);
+ ){
+ List
- items = new ArrayList<>();
+ var res = stm.executeQuery();
+ while(res.next()){
+ items.add(convert(res));
+ }
+ return items;
+
+ }catch (SQLException e){
+ System.out.println("Error reading from database, Reason : "+ e.getMessage());
+ return Collections.emptyList();
+ }
+ }
+
+ public Item findById(int id) {
+ String query = "SELECT * FROM items WHERE id = ?";
+ Item item = null;
+ try(
+ var con = Util.getConnection();
+ var stm = con.prepareStatement(query);
+ ){
+ stm.setInt(1, id);
+ var res = stm.executeQuery();
+ if (res.next()){
+ item = convert(res);
+ }
+ return item;
+ }catch(SQLException e){
+ System.out.println("Error inserting data to database, Reason : "+ e.getMessage());
+ return item;
+ }
+ }
+
+ public boolean insert(Item item) {
+ String query = "INSERT INTO items (name, description, price) VALUES (?,?,?)";
+ try(
+ var con = Util.getConnection();
+ var stm = con.prepareStatement(query);
+ ){
+ //stm.setInt(1, item.getId()); // this should normally be auto
+ stm.setString(1, item.getName());
+ stm.setString(2, item.getDescription());
+ stm.setFloat(3, item.getPrice());
+ stm.executeUpdate();
+ return true;
+ }catch(SQLException e){
+ System.out.println("Error inserting data to database, Reason : "+ e.getMessage());
+ return false;
+ }
+ }
+
+ public boolean update(Item item) {
+ String query = "UPDATE items SET name = ?,description = ?,price = ? WHERE id = ?";
+ try(
+ var con = Util.getConnection();
+ var stm = con.prepareStatement(query);
+ ){
+ stm.setString(1, item.getName());
+ stm.setString(2, item.getDescription());
+ stm.setFloat(3, item.getPrice());
+ stm.setInt(4, item.getId());
+ stm.executeUpdate();
+ return true;
+ }catch(SQLException e){
+ System.out.println("Error updating data to database, Reason : "+ e.getMessage());
+ return false;
+ }
+ }
+
+ public boolean delete(int id) {
+ String query = "DELETE FROM items WHERE id = ?";
+ try(
+ var con = Util.getConnection();
+ var stm = con.prepareStatement(query);
+ ){
+ stm.setInt(1, id);
+ stm.executeUpdate();
+ return true;
+ }catch(SQLException e){
+ System.out.println("Error deleting data from database, Reason : "+ e.getMessage());
+ return false;
+ }
+ }
+
+ protected Item convert(ResultSet res){
+ try{
+ return Item.createItem(
+ res.getInt("id"),
+ res.getString("name"),
+ res.getString("description"),
+ res.getFloat("price"));
+ } catch (SQLException e) {
+ throw new RuntimeException(e);
+ }
+ }
+
+
+
+}
\ No newline at end of file
diff --git a/week5_TinsaeGhilay/shop/src/main/java/net/tinsae/shop/Util.java b/week5_TinsaeGhilay/shop/src/main/java/net/tinsae/shop/Util.java
new file mode 100644
index 0000000..22384c9
--- /dev/null
+++ b/week5_TinsaeGhilay/shop/src/main/java/net/tinsae/shop/Util.java
@@ -0,0 +1,16 @@
+package net.tinsae.shop;
+
+
+import java.sql.Connection;
+import java.sql.DriverManager;
+
+public class Util{
+
+ public static Connection getConnection(){
+ try{
+ return DriverManager.getConnection("jdbc:sqlite:test.db");
+ } catch (Exception e) {
+ throw new RuntimeException(e);
+ }
+ }
+}
\ No newline at end of file
diff --git a/week5_TinsaeGhilay/shop/src/main/resources/META-INF/beans.xml b/week5_TinsaeGhilay/shop/src/main/resources/META-INF/beans.xml
new file mode 100644
index 0000000..96b4c76
--- /dev/null
+++ b/week5_TinsaeGhilay/shop/src/main/resources/META-INF/beans.xml
@@ -0,0 +1,6 @@
+
+
+
+
\ No newline at end of file